function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// Generated automatically by nearley, version 2.20.1
// http://github.com/Hardmath123/nearley
// Bypasses TS6133. Allow declared but unused functions.
// @ts-ignore
function id(d) {
  return d[0];
}

import LexerAdapter from "./LexerAdapter";
import { NodeType } from "./ast";
import { TokenType } from "../lexer/token"; // The lexer here is only to provide the has() method,
// that's used inside the generated grammar definition.
// A proper lexer gets passed to Nearley Parser constructor.

var lexer = new LexerAdapter(function (chunk) {
  return [];
}); // Used for unwrapping grammar rules like:
//
//   rule -> ( foo | bar | baz )
//
// which otherwise produce single element nested inside two arrays

var unwrap = function unwrap(_ref) {
  var _ref2 = _slicedToArray(_ref, 1),
      _ref2$ = _slicedToArray(_ref2[0], 1),
      el = _ref2$[0];

  return el;
};

var toKeywordNode = function toKeywordNode(token) {
  return {
    type: NodeType.keyword,
    tokenType: token.type,
    text: token.text,
    raw: token.raw
  };
};

var addComments = function addComments(node, _ref3) {
  var leading = _ref3.leading,
      trailing = _ref3.trailing;

  if (leading !== null && leading !== void 0 && leading.length) {
    node = _objectSpread(_objectSpread({}, node), {}, {
      leadingComments: leading
    });
  }

  if (trailing !== null && trailing !== void 0 && trailing.length) {
    node = _objectSpread(_objectSpread({}, node), {}, {
      trailingComments: trailing
    });
  }

  return node;
};

;
;
;
;
var grammar = {
  Lexer: lexer,
  ParserRules: [{
    "name": "main$ebnf$1",
    "symbols": []
  }, {
    "name": "main$ebnf$1",
    "symbols": ["main$ebnf$1", "statement"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "main",
    "symbols": ["main$ebnf$1"],
    "postprocess": function postprocess(_ref4) {
      var _ref5 = _slicedToArray(_ref4, 1),
          statements = _ref5[0];

      var last = statements[statements.length - 1];

      if (last && !last.hasSemicolon) {
        // we have fully parsed the whole file
        // discard the last statement when it's empty
        return last.children.length > 0 ? statements : statements.slice(0, -1);
      } else {
        // parsing still in progress, do nothing
        return statements;
      }
    }
  }, {
    "name": "statement$subexpression$1",
    "symbols": [lexer.has("DELIMITER") ? {
      type: "DELIMITER"
    } : DELIMITER]
  }, {
    "name": "statement$subexpression$1",
    "symbols": [lexer.has("EOF") ? {
      type: "EOF"
    } : EOF]
  }, {
    "name": "statement",
    "symbols": ["expressions_or_clauses", "statement$subexpression$1"],
    "postprocess": function postprocess(_ref6) {
      var _ref7 = _slicedToArray(_ref6, 2),
          children = _ref7[0],
          _ref7$ = _slicedToArray(_ref7[1], 1),
          delimiter = _ref7$[0];

      return {
        type: NodeType.statement,
        children: children,
        hasSemicolon: delimiter.type === TokenType.DELIMITER
      };
    }
  }, {
    "name": "expressions_or_clauses$ebnf$1",
    "symbols": []
  }, {
    "name": "expressions_or_clauses$ebnf$1",
    "symbols": ["expressions_or_clauses$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "expressions_or_clauses$ebnf$2",
    "symbols": []
  }, {
    "name": "expressions_or_clauses$ebnf$2",
    "symbols": ["expressions_or_clauses$ebnf$2", "clause"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "expressions_or_clauses",
    "symbols": ["expressions_or_clauses$ebnf$1", "expressions_or_clauses$ebnf$2"],
    "postprocess": function postprocess(_ref8) {
      var _ref9 = _slicedToArray(_ref8, 2),
          expressions = _ref9[0],
          clauses = _ref9[1];

      return [].concat(_toConsumableArray(expressions), _toConsumableArray(clauses));
    }
  }, {
    "name": "clause$subexpression$1",
    "symbols": ["limit_clause"]
  }, {
    "name": "clause$subexpression$1",
    "symbols": ["select_clause"]
  }, {
    "name": "clause$subexpression$1",
    "symbols": ["other_clause"]
  }, {
    "name": "clause$subexpression$1",
    "symbols": ["set_operation"]
  }, {
    "name": "clause",
    "symbols": ["clause$subexpression$1"],
    "postprocess": unwrap
  }, {
    "name": "limit_clause$ebnf$1$subexpression$1$ebnf$1",
    "symbols": ["free_form_sql"]
  }, {
    "name": "limit_clause$ebnf$1$subexpression$1$ebnf$1",
    "symbols": ["limit_clause$ebnf$1$subexpression$1$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "limit_clause$ebnf$1$subexpression$1",
    "symbols": [lexer.has("COMMA") ? {
      type: "COMMA"
    } : COMMA, "limit_clause$ebnf$1$subexpression$1$ebnf$1"]
  }, {
    "name": "limit_clause$ebnf$1",
    "symbols": ["limit_clause$ebnf$1$subexpression$1"],
    "postprocess": id
  }, {
    "name": "limit_clause$ebnf$1",
    "symbols": [],
    "postprocess": function postprocess() {
      return null;
    }
  }, {
    "name": "limit_clause",
    "symbols": [lexer.has("LIMIT") ? {
      type: "LIMIT"
    } : LIMIT, "_", "expression_chain_", "limit_clause$ebnf$1"],
    "postprocess": function postprocess(_ref10) {
      var _ref11 = _slicedToArray(_ref10, 4),
          limitToken = _ref11[0],
          _ = _ref11[1],
          exp1 = _ref11[2],
          optional = _ref11[3];

      if (optional) {
        var _optional = _slicedToArray(optional, 2),
            comma = _optional[0],
            exp2 = _optional[1];

        return {
          type: NodeType.limit_clause,
          limitKw: addComments(toKeywordNode(limitToken), {
            trailing: _
          }),
          offset: exp1,
          count: exp2
        };
      } else {
        return {
          type: NodeType.limit_clause,
          limitKw: addComments(toKeywordNode(limitToken), {
            trailing: _
          }),
          count: exp1
        };
      }
    }
  }, {
    "name": "select_clause$subexpression$1$ebnf$1",
    "symbols": []
  }, {
    "name": "select_clause$subexpression$1$ebnf$1",
    "symbols": ["select_clause$subexpression$1$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "select_clause$subexpression$1",
    "symbols": ["all_columns_asterisk", "select_clause$subexpression$1$ebnf$1"]
  }, {
    "name": "select_clause$subexpression$1$ebnf$2",
    "symbols": []
  }, {
    "name": "select_clause$subexpression$1$ebnf$2",
    "symbols": ["select_clause$subexpression$1$ebnf$2", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "select_clause$subexpression$1",
    "symbols": ["asteriskless_free_form_sql", "select_clause$subexpression$1$ebnf$2"]
  }, {
    "name": "select_clause",
    "symbols": [lexer.has("RESERVED_SELECT") ? {
      type: "RESERVED_SELECT"
    } : RESERVED_SELECT, "select_clause$subexpression$1"],
    "postprocess": function postprocess(_ref12) {
      var _ref13 = _slicedToArray(_ref12, 2),
          nameToken = _ref13[0],
          _ref13$ = _slicedToArray(_ref13[1], 2),
          exp = _ref13$[0],
          expressions = _ref13$[1];

      return {
        type: NodeType.clause,
        nameKw: toKeywordNode(nameToken),
        children: [exp].concat(_toConsumableArray(expressions))
      };
    }
  }, {
    "name": "select_clause",
    "symbols": [lexer.has("RESERVED_SELECT") ? {
      type: "RESERVED_SELECT"
    } : RESERVED_SELECT],
    "postprocess": function postprocess(_ref14) {
      var _ref15 = _slicedToArray(_ref14, 1),
          nameToken = _ref15[0];

      return {
        type: NodeType.clause,
        name: toKeywordNode(nameToken),
        children: []
      };
    }
  }, {
    "name": "all_columns_asterisk",
    "symbols": [lexer.has("ASTERISK") ? {
      type: "ASTERISK"
    } : ASTERISK],
    "postprocess": function postprocess() {
      return {
        type: NodeType.all_columns_asterisk
      };
    }
  }, {
    "name": "other_clause$ebnf$1",
    "symbols": []
  }, {
    "name": "other_clause$ebnf$1",
    "symbols": ["other_clause$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "other_clause",
    "symbols": [lexer.has("RESERVED_COMMAND") ? {
      type: "RESERVED_COMMAND"
    } : RESERVED_COMMAND, "other_clause$ebnf$1"],
    "postprocess": function postprocess(_ref16) {
      var _ref17 = _slicedToArray(_ref16, 2),
          nameToken = _ref17[0],
          children = _ref17[1];

      return {
        type: NodeType.clause,
        nameKw: toKeywordNode(nameToken),
        children: children
      };
    }
  }, {
    "name": "set_operation$ebnf$1",
    "symbols": []
  }, {
    "name": "set_operation$ebnf$1",
    "symbols": ["set_operation$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "set_operation",
    "symbols": [lexer.has("RESERVED_SET_OPERATION") ? {
      type: "RESERVED_SET_OPERATION"
    } : RESERVED_SET_OPERATION, "set_operation$ebnf$1"],
    "postprocess": function postprocess(_ref18) {
      var _ref19 = _slicedToArray(_ref18, 2),
          nameToken = _ref19[0],
          children = _ref19[1];

      return {
        type: NodeType.set_operation,
        nameKw: toKeywordNode(nameToken),
        children: children
      };
    }
  }, {
    "name": "expression_chain_$ebnf$1",
    "symbols": ["expression_with_comments_"]
  }, {
    "name": "expression_chain_$ebnf$1",
    "symbols": ["expression_chain_$ebnf$1", "expression_with_comments_"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "expression_chain_",
    "symbols": ["expression_chain_$ebnf$1"],
    "postprocess": id
  }, {
    "name": "expression_with_comments_",
    "symbols": ["expression", "_"],
    "postprocess": function postprocess(_ref20) {
      var _ref21 = _slicedToArray(_ref20, 2),
          expr = _ref21[0],
          _ = _ref21[1];

      return addComments(expr, {
        trailing: _
      });
    }
  }, {
    "name": "free_form_sql$subexpression$1",
    "symbols": ["asteriskless_free_form_sql"]
  }, {
    "name": "free_form_sql$subexpression$1",
    "symbols": ["asterisk"]
  }, {
    "name": "free_form_sql",
    "symbols": ["free_form_sql$subexpression$1"],
    "postprocess": unwrap
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["asteriskless_expression"]
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["between_predicate"]
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["case_expression"]
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["comma"]
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["comment"]
  }, {
    "name": "asteriskless_free_form_sql$subexpression$1",
    "symbols": ["other_keyword"]
  }, {
    "name": "asteriskless_free_form_sql",
    "symbols": ["asteriskless_free_form_sql$subexpression$1"],
    "postprocess": unwrap
  }, {
    "name": "expression$subexpression$1",
    "symbols": ["asteriskless_expression"]
  }, {
    "name": "expression$subexpression$1",
    "symbols": ["asterisk"]
  }, {
    "name": "expression",
    "symbols": ["expression$subexpression$1"],
    "postprocess": unwrap
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["array_subscript"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["function_call"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["property_access"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["parenthesis"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["curly_braces"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["square_brackets"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["operator"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["identifier"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["parameter"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["literal"]
  }, {
    "name": "asteriskless_expression$subexpression$1",
    "symbols": ["keyword"]
  }, {
    "name": "asteriskless_expression",
    "symbols": ["asteriskless_expression$subexpression$1"],
    "postprocess": unwrap
  }, {
    "name": "array_subscript",
    "symbols": [lexer.has("ARRAY_IDENTIFIER") ? {
      type: "ARRAY_IDENTIFIER"
    } : ARRAY_IDENTIFIER, "_", "square_brackets"],
    "postprocess": function postprocess(_ref22) {
      var _ref23 = _slicedToArray(_ref22, 3),
          arrayToken = _ref23[0],
          _ = _ref23[1],
          brackets = _ref23[2];

      return {
        type: NodeType.array_subscript,
        array: addComments({
          type: NodeType.identifier,
          text: arrayToken.text
        }, {
          trailing: _
        }),
        parenthesis: brackets
      };
    }
  }, {
    "name": "array_subscript",
    "symbols": [lexer.has("ARRAY_KEYWORD") ? {
      type: "ARRAY_KEYWORD"
    } : ARRAY_KEYWORD, "_", "square_brackets"],
    "postprocess": function postprocess(_ref24) {
      var _ref25 = _slicedToArray(_ref24, 3),
          arrayToken = _ref25[0],
          _ = _ref25[1],
          brackets = _ref25[2];

      return {
        type: NodeType.array_subscript,
        array: addComments(toKeywordNode(arrayToken), {
          trailing: _
        }),
        parenthesis: brackets
      };
    }
  }, {
    "name": "function_call",
    "symbols": [lexer.has("RESERVED_FUNCTION_NAME") ? {
      type: "RESERVED_FUNCTION_NAME"
    } : RESERVED_FUNCTION_NAME, "_", "parenthesis"],
    "postprocess": function postprocess(_ref26) {
      var _ref27 = _slicedToArray(_ref26, 3),
          nameToken = _ref27[0],
          _ = _ref27[1],
          parens = _ref27[2];

      return {
        type: NodeType.function_call,
        nameKw: addComments(toKeywordNode(nameToken), {
          trailing: _
        }),
        parenthesis: parens
      };
    }
  }, {
    "name": "parenthesis",
    "symbols": [{
      "literal": "("
    }, "expressions_or_clauses", {
      "literal": ")"
    }],
    "postprocess": function postprocess(_ref28) {
      var _ref29 = _slicedToArray(_ref28, 3),
          open = _ref29[0],
          children = _ref29[1],
          close = _ref29[2];

      return {
        type: NodeType.parenthesis,
        children: children,
        openParen: "(",
        closeParen: ")"
      };
    }
  }, {
    "name": "curly_braces$ebnf$1",
    "symbols": []
  }, {
    "name": "curly_braces$ebnf$1",
    "symbols": ["curly_braces$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "curly_braces",
    "symbols": [{
      "literal": "{"
    }, "curly_braces$ebnf$1", {
      "literal": "}"
    }],
    "postprocess": function postprocess(_ref30) {
      var _ref31 = _slicedToArray(_ref30, 3),
          open = _ref31[0],
          children = _ref31[1],
          close = _ref31[2];

      return {
        type: NodeType.parenthesis,
        children: children,
        openParen: "{",
        closeParen: "}"
      };
    }
  }, {
    "name": "square_brackets$ebnf$1",
    "symbols": []
  }, {
    "name": "square_brackets$ebnf$1",
    "symbols": ["square_brackets$ebnf$1", "free_form_sql"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "square_brackets",
    "symbols": [{
      "literal": "["
    }, "square_brackets$ebnf$1", {
      "literal": "]"
    }],
    "postprocess": function postprocess(_ref32) {
      var _ref33 = _slicedToArray(_ref32, 3),
          open = _ref33[0],
          children = _ref33[1],
          close = _ref33[2];

      return {
        type: NodeType.parenthesis,
        children: children,
        openParen: "[",
        closeParen: "]"
      };
    }
  }, {
    "name": "property_access$subexpression$1",
    "symbols": ["identifier"]
  }, {
    "name": "property_access$subexpression$1",
    "symbols": ["array_subscript"]
  }, {
    "name": "property_access$subexpression$1",
    "symbols": ["all_columns_asterisk"]
  }, {
    "name": "property_access",
    "symbols": ["expression", "_", lexer.has("DOT") ? {
      type: "DOT"
    } : DOT, "_", "property_access$subexpression$1"],
    "postprocess": // Allowing property to be <array_subscript> is currently a hack.
    // A better way would be to allow <property_access> on the left side of array_subscript,
    // but we currently can't do that because of another hack that requires
    // %ARRAY_IDENTIFIER on the left side of <array_subscript>.
    function postprocess(_ref34) {
      var _ref35 = _slicedToArray(_ref34, 5),
          object = _ref35[0],
          _1 = _ref35[1],
          dot = _ref35[2],
          _2 = _ref35[3],
          _ref35$ = _slicedToArray(_ref35[4], 1),
          property = _ref35$[0];

      return {
        type: NodeType.property_access,
        object: addComments(object, {
          trailing: _1
        }),
        property: addComments(property, {
          leading: _2
        })
      };
    }
  }, {
    "name": "between_predicate",
    "symbols": [lexer.has("BETWEEN") ? {
      type: "BETWEEN"
    } : BETWEEN, "_", "expression", "_", lexer.has("AND") ? {
      type: "AND"
    } : AND, "_", "expression"],
    "postprocess": function postprocess(_ref36) {
      var _ref37 = _slicedToArray(_ref36, 7),
          betweenToken = _ref37[0],
          _1 = _ref37[1],
          expr1 = _ref37[2],
          _2 = _ref37[3],
          andToken = _ref37[4],
          _3 = _ref37[5],
          expr2 = _ref37[6];

      return {
        type: NodeType.between_predicate,
        betweenKw: toKeywordNode(betweenToken),
        expr1: [addComments(expr1, {
          leading: _1,
          trailing: _2
        })],
        andKw: toKeywordNode(andToken),
        expr2: [addComments(expr2, {
          leading: _3
        })]
      };
    }
  }, {
    "name": "case_expression$ebnf$1",
    "symbols": ["expression_chain_"],
    "postprocess": id
  }, {
    "name": "case_expression$ebnf$1",
    "symbols": [],
    "postprocess": function postprocess() {
      return null;
    }
  }, {
    "name": "case_expression$ebnf$2",
    "symbols": []
  }, {
    "name": "case_expression$ebnf$2",
    "symbols": ["case_expression$ebnf$2", "case_clause"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "case_expression",
    "symbols": [lexer.has("CASE") ? {
      type: "CASE"
    } : CASE, "_", "case_expression$ebnf$1", "case_expression$ebnf$2", lexer.has("END") ? {
      type: "END"
    } : END],
    "postprocess": function postprocess(_ref38) {
      var _ref39 = _slicedToArray(_ref38, 5),
          caseToken = _ref39[0],
          _ = _ref39[1],
          expr = _ref39[2],
          clauses = _ref39[3],
          endToken = _ref39[4];

      return {
        type: NodeType.case_expression,
        caseKw: addComments(toKeywordNode(caseToken), {
          trailing: _
        }),
        endKw: toKeywordNode(endToken),
        expr: expr || [],
        clauses: clauses
      };
    }
  }, {
    "name": "case_clause",
    "symbols": [lexer.has("WHEN") ? {
      type: "WHEN"
    } : WHEN, "_", "expression_chain_", lexer.has("THEN") ? {
      type: "THEN"
    } : THEN, "_", "expression_chain_"],
    "postprocess": function postprocess(_ref40) {
      var _ref41 = _slicedToArray(_ref40, 6),
          whenToken = _ref41[0],
          _1 = _ref41[1],
          cond = _ref41[2],
          thenToken = _ref41[3],
          _2 = _ref41[4],
          expr = _ref41[5];

      return {
        type: NodeType.case_when,
        whenKw: addComments(toKeywordNode(whenToken), {
          trailing: _1
        }),
        thenKw: addComments(toKeywordNode(thenToken), {
          trailing: _2
        }),
        condition: cond,
        result: expr
      };
    }
  }, {
    "name": "case_clause",
    "symbols": [lexer.has("ELSE") ? {
      type: "ELSE"
    } : ELSE, "_", "expression_chain_"],
    "postprocess": function postprocess(_ref42) {
      var _ref43 = _slicedToArray(_ref42, 3),
          elseToken = _ref43[0],
          _ = _ref43[1],
          expr = _ref43[2];

      return {
        type: NodeType.case_else,
        elseKw: addComments(toKeywordNode(elseToken), {
          trailing: _
        }),
        result: expr
      };
    }
  }, {
    "name": "comma$subexpression$1",
    "symbols": [lexer.has("COMMA") ? {
      type: "COMMA"
    } : COMMA]
  }, {
    "name": "comma",
    "symbols": ["comma$subexpression$1"],
    "postprocess": function postprocess(_ref44) {
      var _ref45 = _slicedToArray(_ref44, 1),
          _ref45$ = _slicedToArray(_ref45[0], 1),
          token = _ref45$[0];

      return {
        type: NodeType.comma
      };
    }
  }, {
    "name": "asterisk$subexpression$1",
    "symbols": [lexer.has("ASTERISK") ? {
      type: "ASTERISK"
    } : ASTERISK]
  }, {
    "name": "asterisk",
    "symbols": ["asterisk$subexpression$1"],
    "postprocess": function postprocess(_ref46) {
      var _ref47 = _slicedToArray(_ref46, 1),
          _ref47$ = _slicedToArray(_ref47[0], 1),
          token = _ref47$[0];

      return {
        type: NodeType.operator,
        text: token.text
      };
    }
  }, {
    "name": "operator$subexpression$1",
    "symbols": [lexer.has("OPERATOR") ? {
      type: "OPERATOR"
    } : OPERATOR]
  }, {
    "name": "operator",
    "symbols": ["operator$subexpression$1"],
    "postprocess": function postprocess(_ref48) {
      var _ref49 = _slicedToArray(_ref48, 1),
          _ref49$ = _slicedToArray(_ref49[0], 1),
          token = _ref49$[0];

      return {
        type: NodeType.operator,
        text: token.text
      };
    }
  }, {
    "name": "identifier$subexpression$1",
    "symbols": [lexer.has("IDENTIFIER") ? {
      type: "IDENTIFIER"
    } : IDENTIFIER]
  }, {
    "name": "identifier$subexpression$1",
    "symbols": [lexer.has("QUOTED_IDENTIFIER") ? {
      type: "QUOTED_IDENTIFIER"
    } : QUOTED_IDENTIFIER]
  }, {
    "name": "identifier$subexpression$1",
    "symbols": [lexer.has("VARIABLE") ? {
      type: "VARIABLE"
    } : VARIABLE]
  }, {
    "name": "identifier",
    "symbols": ["identifier$subexpression$1"],
    "postprocess": function postprocess(_ref50) {
      var _ref51 = _slicedToArray(_ref50, 1),
          _ref51$ = _slicedToArray(_ref51[0], 1),
          token = _ref51$[0];

      return {
        type: NodeType.identifier,
        text: token.text
      };
    }
  }, {
    "name": "parameter$subexpression$1",
    "symbols": [lexer.has("NAMED_PARAMETER") ? {
      type: "NAMED_PARAMETER"
    } : NAMED_PARAMETER]
  }, {
    "name": "parameter$subexpression$1",
    "symbols": [lexer.has("QUOTED_PARAMETER") ? {
      type: "QUOTED_PARAMETER"
    } : QUOTED_PARAMETER]
  }, {
    "name": "parameter$subexpression$1",
    "symbols": [lexer.has("NUMBERED_PARAMETER") ? {
      type: "NUMBERED_PARAMETER"
    } : NUMBERED_PARAMETER]
  }, {
    "name": "parameter$subexpression$1",
    "symbols": [lexer.has("POSITIONAL_PARAMETER") ? {
      type: "POSITIONAL_PARAMETER"
    } : POSITIONAL_PARAMETER]
  }, {
    "name": "parameter",
    "symbols": ["parameter$subexpression$1"],
    "postprocess": function postprocess(_ref52) {
      var _ref53 = _slicedToArray(_ref52, 1),
          _ref53$ = _slicedToArray(_ref53[0], 1),
          token = _ref53$[0];

      return {
        type: NodeType.parameter,
        key: token.key,
        text: token.text
      };
    }
  }, {
    "name": "literal$subexpression$1",
    "symbols": [lexer.has("NUMBER") ? {
      type: "NUMBER"
    } : NUMBER]
  }, {
    "name": "literal$subexpression$1",
    "symbols": [lexer.has("STRING") ? {
      type: "STRING"
    } : STRING]
  }, {
    "name": "literal",
    "symbols": ["literal$subexpression$1"],
    "postprocess": function postprocess(_ref54) {
      var _ref55 = _slicedToArray(_ref54, 1),
          _ref55$ = _slicedToArray(_ref55[0], 1),
          token = _ref55$[0];

      return {
        type: NodeType.literal,
        text: token.text
      };
    }
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("RESERVED_KEYWORD") ? {
      type: "RESERVED_KEYWORD"
    } : RESERVED_KEYWORD]
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("RESERVED_PHRASE") ? {
      type: "RESERVED_PHRASE"
    } : RESERVED_PHRASE]
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("RESERVED_JOIN") ? {
      type: "RESERVED_JOIN"
    } : RESERVED_JOIN]
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("AND") ? {
      type: "AND"
    } : AND]
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("OR") ? {
      type: "OR"
    } : OR]
  }, {
    "name": "keyword$subexpression$1",
    "symbols": [lexer.has("XOR") ? {
      type: "XOR"
    } : XOR]
  }, {
    "name": "keyword",
    "symbols": ["keyword$subexpression$1"],
    "postprocess": function postprocess(_ref56) {
      var _ref57 = _slicedToArray(_ref56, 1),
          _ref57$ = _slicedToArray(_ref57[0], 1),
          token = _ref57$[0];

      return toKeywordNode(token);
    }
  }, {
    "name": "other_keyword$subexpression$1",
    "symbols": [lexer.has("WHEN") ? {
      type: "WHEN"
    } : WHEN]
  }, {
    "name": "other_keyword$subexpression$1",
    "symbols": [lexer.has("THEN") ? {
      type: "THEN"
    } : THEN]
  }, {
    "name": "other_keyword$subexpression$1",
    "symbols": [lexer.has("ELSE") ? {
      type: "ELSE"
    } : ELSE]
  }, {
    "name": "other_keyword$subexpression$1",
    "symbols": [lexer.has("END") ? {
      type: "END"
    } : END]
  }, {
    "name": "other_keyword",
    "symbols": ["other_keyword$subexpression$1"],
    "postprocess": function postprocess(_ref58) {
      var _ref59 = _slicedToArray(_ref58, 1),
          _ref59$ = _slicedToArray(_ref59[0], 1),
          token = _ref59$[0];

      return toKeywordNode(token);
    }
  }, {
    "name": "_$ebnf$1",
    "symbols": []
  }, {
    "name": "_$ebnf$1",
    "symbols": ["_$ebnf$1", "comment"],
    "postprocess": function postprocess(d) {
      return d[0].concat([d[1]]);
    }
  }, {
    "name": "_",
    "symbols": ["_$ebnf$1"],
    "postprocess": function postprocess(_ref60) {
      var _ref61 = _slicedToArray(_ref60, 1),
          comments = _ref61[0];

      return comments;
    }
  }, {
    "name": "comment",
    "symbols": [lexer.has("LINE_COMMENT") ? {
      type: "LINE_COMMENT"
    } : LINE_COMMENT],
    "postprocess": function postprocess(_ref62) {
      var _ref63 = _slicedToArray(_ref62, 1),
          token = _ref63[0];

      return {
        type: NodeType.line_comment,
        text: token.text,
        precedingWhitespace: token.precedingWhitespace
      };
    }
  }, {
    "name": "comment",
    "symbols": [lexer.has("BLOCK_COMMENT") ? {
      type: "BLOCK_COMMENT"
    } : BLOCK_COMMENT],
    "postprocess": function postprocess(_ref64) {
      var _ref65 = _slicedToArray(_ref64, 1),
          token = _ref65[0];

      return {
        type: NodeType.block_comment,
        text: token.text,
        precedingWhitespace: token.precedingWhitespace
      };
    }
  }],
  ParserStart: "main"
};
export default grammar;
//# sourceMappingURL=grammar.js.map